/***********	dp_calc.c	***********/
	{1, 10},		/* 356 fW^l̍XV[g */
	{-422, 423},		/* 357 ~TCV{EItZbg(wW)*/
	{-422, 423}		/* 358 ~TCV{EItZbg(xW)*/

int	data_check(int dno)
{
	int	error, n;
	short	high, low;

	if (dno == 27) {
		/* EH[jOPCQ */
		high = (input_data[27] >> 8) & 0x00ff;
		low = input_data[27] & 0x00ff;
		error = (CHECK(high, 0, 1) || CHECK(low, 0, 1));
	} else if (dno == 28) {
		/* EH[jORCS */
		high = (input_data[28] >> 8) & 0x00ff;
		low = input_data[28] & 0x00ff;
		error = (CHECK(high, 0, 1) || CHECK(low, 0, 1));
	} else if (dno == 29) {
		/* ~TCV{̎ށC~TCTmXe[^X */
		high = (input_data[29] >> 8) & 0x00ff;
		low = input_data[29] & 0x00ff;
		error = (CHECK(high, 0, 3) || CHECK(low, 0, 1));
	}else if (dno <= 45) {
		/* QVCQWCQXԍO`ST܂ł̃f[^ */
		error = (CHECK(input_data[dno], data_check_tbl1[dno][0],
						data_check_tbl1[dno][1]));
	} else if (dno <= 345) {
		/* Qf[^iԍSU`RSTj */
		n = (dno - 46) % 3;
		error = (CHECK(input_data[dno], data_check_tbl2[n][0],
						data_check_tbl2[n][1]));
*	} else if (dno <= 358) {
*		/* ԍRSU`RTW܂ł̃f[^ */
		n = dno - 346;
		error = (CHECK(input_data[dno], data_check_tbl3[n][0],
						data_check_tbl3[n][1]));
	} else
		error = 0;

	if (error)
		data_error_flag = 1;	/* f[^G[tOZbg */

	return(error);
}
/***********	inpdata.c	***********/
static	void	dp_missile_symbol(void)
{
	long	x, y;

	/* f[^`FbN */
	if (data_check(7) || data_check(357) || data_check(358))
		return;

	/* ZTenuO͕̎\Ȃ */
	if (input_data[7] == 0)
		return;

	/* ~TĈwCxWvZ */
	x = (long)dot_video * input_data[30] / input_data[7] + input_data[357];
	y = (long)dot_video * input_data[31] / input_data[7] - input_data[358];

	/* ʓɂȂꍇ\Ȃ */
	if (x > 423 || x < -423 || y > 423 || y < -423)
		return;

	/* ~TCʒuiowOTCoxOTj̐ݒ */
	dp.PX05 = DOT_TO_DP(x);
	dp.PY05 = DOT_TO_DP(y);

	/* o^`rbgݒ */
	SET_PABIT(PA_K005);
}

static	void	dp_missile_sonzai1(void)
{
	long	x, y;

	/* ԍQX̏ʂWQ͕̎\Ȃ */
	if ((input_data[29] & 0xff00) == 0x200)
		return;

	/* }XOK͈̔͂ɂȂꍇ͕\Ȃ */
	if (input_data[30] > 9000 || input_data[30] < -9000)
		return;

	/* f[^`FbN */
	if (data_check(7) || data_check(8) || data_check(9) ||
					data_check(357) || data_check(358))
		return;

	/* ZTenuO͕̎\Ȃ */
	if (input_data[7] == 0)
		return;

	/* ~TCV{ƏdȂꍇ͕\Ȃ */
	x = (long)dot_video * input_data[30] / input_data[7] - input_data[8] +
						input_data[357];
	y = (long)dot_video * input_data[31] / input_data[7] + input_data[9] -
						input_data[358];
	if (DOT_TO_MM(sqrt(x * x + y * y)) <= 1800)
		return;

	/* px(R06)̐ݒ */
	dp.R06 = atan((short)y, (short)x);

	/* o^`rbgݒ */
	SET_PABIT(PA_K006);
}

static	void	dp_missile_hyouji(void)
{
	long	x, y;
	short	l;

	/* ԍQX̏ʂWP͕̎\Ȃ */
	if ((input_data[29] & 0xff00) == 0x100)
		return;

	/* f[^`FbN */
	if (data_check(7) || data_check(8) || data_check(9) ||
					data_check(357) || data_check(358))
		return;

	/* ZTenuO͕̎\Ȃ */
	if (input_data[7] == 0)
		return;

	/* ~TCʒûwCxWvZ */
	x = (long)dot_video * input_data[30] / input_data[7] + input_data[357];
	y = (long)dot_video * input_data[31] / input_data[7] - input_data[358];

	/* ʓɂȂꍇ\Ȃ */
	if (x > 423 || x < -423 || y > 423 || y < -423)
		return;

	/* eBN̑Έʒuɕϊ */
	x -= input_data[8];
	y += input_data[9];

	/* vZ */
	l = DOT_TO_MM(sqrt(x * x + y * y)) - 300;

	/* Oȉ̏ꍇ͕\Ȃ */
	if (l < 0)
		return;

	/* ̒(LX08)̐ݒ */
	dp.LX08 = MM_TO_DP(l);

	/* px(R08)̐ݒ */
	dp.R08 = atan((short)y, (short)x);

	/* o^`rbgݒ */
	SET_PABIT(PA_K008);
}

static	void	dp_missile_sonzai2(void)
{
	register long	x, y, rx, ry, tx, ty, len;

	/* ԍQX̏ʂWP͕̎\Ȃ */
	if ((input_data[29] & 0xff00) == 0x100)
		return;

	/* f[^`FbN */
	if (data_check(7) || data_check(8) || data_check(9) ||
					data_check(357) || data_check(358))
		return;

	/* ZTenuO͕̎\Ȃ */
	if (input_data[7] == 0)
		return;

	/* }XOK͈̔͂ɂȂꍇ͕\Ȃ */
	if (input_data[30] > 9000 || input_data[30] < -9000)
		return;

	/* ~TCʒûwCxWvZ */
	x = (long)dot_video * input_data[30] / input_data[7] + input_data[357];
	y = (long)dot_video * input_data[31] / input_data[7] - input_data[358];

	/* ʓɂꍇ\Ȃ */
	if (x <= 423 && x >= -423 && y <= 423 && y >= -423)
		return;

	/* eBN̑Έʒuɕϊ */
	rx = x - input_data[8];
	ry = y + input_data[9];

	/* px(R07)̐ݒ */
	dp.R07 = atan((short)ry, (short)rx);

	/* wCẍʒu̐Βl߂ */
	x = ABS(x);
	y = ABS(y);
	rx = ABS(rx);
	ry = ABS(ry);

	/* w̒ʓiSOOhbgȓjɎ߂ */
	if (x > 400) {
		tx = rx - (x - 400);
		ty = ry * tx / rx;
		y -= ry - ty;
		rx = tx;
		ry = ty;
	}

	/* x̒ʓiRQOhbgȓjɎ߂ */
	if (y > 320) {
		tx = ry - (y - 320);
		rx = rx * tx / ry;
		ry = tx;
	}

	/* ߂ */
	len = DOT_TO_MM(sqrt(rx * rx + ry * ry));

	/* SDOTi̒jZꍇ͕\Ȃ */
	if (len < 405)
		return;

	/* (LX07)̐ݒ */
	dp.LX07 = MM_TO_DP(len - 405);

	/* o^`rbgݒ */
	SET_PABIT(PA_K007);
}

static	void	dp_obst_kyori(void)
{
	short	s1, s2;

	static	ushort	legend[5] = {
		FONT8_O, FONT8_B, FONT8_S, FONT8_T, FONT8_SP
	};

	/* f[^`FbN */
	if (data_check(44) || data_check(45) ||
				data_check(354) || data_check(355))
		return;

	/* WFhZbg */
	COPY_WORD(&dp.A141[0], legend, 5);

	if (digital_update_flag) {
		/* Zbg */
		if (input_data[45] == 0) {
			SET_WORD(&dp.A141[5], FONT8_SP, 4);
			dp.C140 = COLOR_YELLOW;		/*  */
		} else {
			tonumL(input_data[45], &dp.A141[5], 3, font8_tbl,
								FONT8_SP);

			/* c̃GAɃXy[XZbg */
			dp.A141[8] = FONT8_SP;

			/* lPCQo */
			s1 = input_data[354];
			s2 = input_data[355];
			if (s2 <= s1)
				s2 = 1000;

			/* FR[hZbg */
			if (input_data[45] < s1)
				dp.C140 = COLOR_RED;		/*  */
			else if (input_data[45] < s2)
				dp.C140 = COLOR_YELLOW;		/*  */
			else
				dp.C140 = COLOR_GREEN;		/*  */
		}
	}

	/* o^`rbgݒ */
	SET_PABIT(PA_KD140);
}
